// DS102Dlg.h : wb_[ t@C
//
//_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
//
//  SURUGA SEIKI@DS102controler  sample program
//
//  This sample program is using the MSComm control offered by Microsoft.
//
//
//  A hardware requirement is described below.
//    -- The Comm port and controller of PC are connected with the cross cable.
//    -- A setup (DIP switch) of a controller is set as 35400bps.
//
//_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

#include "MyButton.h"
//{{AFX_INCLUDES()
#include "mscomm.h"
//}}AFX_INCLUDES

#if !defined(AFX_DS102DLG_H__4501DBB9_3712_4A94_8556_ADBD0DA0FC3C__INCLUDED_)
#define AFX_DS102DLG_H__4501DBB9_3712_4A94_8556_ADBD0DA0FC3C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CDS102Dlg Dialog

//STATUS1
#define DIRECTION	1
#define		CW		1
#define		CCW		0
#define	MLIMIT		2
#define	SLIMIT		4
#define ESTOP		8
#define	ORGPOINT	16
#define	HOME		32
#define	MOVING		64

//STATUS2
#define CWML		1
#define CCWML		2
#define	CWSL		4
#define	CCWSL		8
#define	CWSLE		16
#define	CCWSLE		32

//STATUS3
#define	AXISENABLE	1
#define	DRIVERTYPE	2

class CDS102Dlg : public CDialog
{
// Construction
public:
	CDS102Dlg(CWnd* pParent = NULL);	// A standard constructor

//  
	//{{AFX_DATA(CDS102Dlg)
	enum { IDD = IDD_DS102_DIALOG };
	CMyButton	m_btnCW2;
	CMyButton	m_btnCW1;
	CMyButton	m_btnCCW2;
	CMyButton	m_btnCCW1;
	CMSComm	m_MSComm;
	double	m_dPosition1;
	double	m_dPosition2;
	UINT	m_uiSpeed1;
	UINT	m_uiSpeed2;
	double	m_dStep1;
	double	m_dStep2;
	CString	m_strUnit1;
	CString	m_strUnit2;
	//}}AFX_DATA

	// 
	//{{AFX_VIRTUAL(CDS102Dlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// 
protected:
	HICON m_hIcon;

	//
	//{{AFX_MSG(CDS102Dlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnCont();
	afx_msg void OnStep();
	afx_msg void OnPoint();
	afx_msg void OnOrg();
	afx_msg void OnMenuAxis1();
	afx_msg void OnMenuAxis2();
	afx_msg void OnEmg();
	afx_msg void OnClear1();
	afx_msg void OnClear2();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnEnd();
	afx_msg void OnMenuComm();
	//}}AFX_MSG
	void OnDown(WPARAM wParam,LPARAM lParam =0);	
	void OnUp(WPARAM wParam ,LPARAM lParam =0);
	DECLARE_MESSAGE_MAP()

private:
	int iMoveStyle;							// move mode: -- 0 to 3 --(Cont,Step,Point,ORG)
	int iUnit[2];							// Display unit :-- 0 to 4 --(Pulse,um,mm,deg,mrad)
	int iCommPort;							// Comm port Number:-- 1 to 16
	BOOL CommInit();						// The function which initializes a Comm port
	void SetUnit(int iAxisNumber);			// The function which changes a display unit
	BOOL GetPosition(int iAxisNumber);		// The function which acquires the coordinates of a selected axis
	BOOL CheckStop(int iAxisNumber = 0);	// The function which performs a stop check
	BOOL GetFSpeed(int iAxisNumber);		// The function which obtains drive speed (F)
	int iTimer;								// The axis which needs to update a timer.(it displays in a bit.)
	int iFSpeed[2];							// F speed
	UINT nTimerID;							// ID for timers
	char iStatus1[2];						// Status 1
	char iStatus2[2];						// Status 2
	char iStatus3[2];						// Status 3

	BOOL GetStatus1(int iAxisNumber);		// Driver status 1 acquisition function
	BOOL GetStatus2(int iAxisNumber);		// Driver status 2 acquisition function
	BOOL GetStatus3(int iAxisNumber);		// Driver status 3 acquisition function
	void UpdateStatus();					// The function which updates status
	void CheckMessage();					// Windows message processing function

public:
	BOOL SetCommPort(int iPort);			// setting a Comm port function
	BOOL Send(CString strMessage);			// Command transmitting function
	BOOL Receive(CString& strMessage);		// Response massage receiving function
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_DS102DLG_H__4501DBB9_3712_4A94_8556_ADBD0DA0FC3C__INCLUDED_)
